var Q = Object.defineProperty;
var ee = (e, t, r) => t in e ? Q(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var E = (e, t, r) => (ee(e, typeof t != "symbol" ? t + "" : t, r), r);
import { AvailableSubscriptionProducts as te, ProductType as g } from "@zebrainy/front-types";
import y from "moment";
import { default as Pr } from "moment";
import { CatalogConfigValidator as re } from "@zebrainy/catalog-config";
import C from "axios";
const S = class {
  static init(t, r) {
    S.protocols = t, S.isDev = r;
  }
  static resolve(t, r) {
    const n = (r == null ? void 0 : r.isBrowser) == null ? S.isDev : r.isBrowser;
    if (!t)
      return t;
    if (t.startsWith("/"))
      return H(t) && !j(n) ? Se(S.protocols, t) : (r != null && r.isBackup && (t = t.replace(/^\/[^\/]*/, "/backup")), t);
    if (t.startsWith(".") || !t.includes("://"))
      return t;
    let [o, ...s] = t.split("://");
    if (o == "http" || o == "https")
      return t;
    let i = s.join("://");
    if (j(n))
      return `/cache/${o}/${i}`;
    let c = S.protocols[o];
    return c ? `${c}/${i}` : t;
  }
};
let I = S;
E(I, "protocols"), E(I, "isDev");
const Ye = (e) => new Promise((t) => setTimeout(t, e)), Je = (e) => {
  const t = {}, r = [e];
  for (; r.length; ) {
    const n = r.pop();
    for (let o in n) {
      const s = n[o];
      !Array.isArray(s) && typeof s == "object" && s !== null ? r.push(s) : t[o] = s;
    }
  }
  return t;
}, V = (e) => {
  var t, r, n;
  return C.isAxiosError(e) ? `${e.name} ${e.code || ((t = e.response) == null ? void 0 : t.status) || ""} ${((r = e.response) == null ? void 0 : r.statusText) || ""}:${e.config.method} ${e.config.baseURL || ""}${e.config.url || ""}
${JSON.stringify((n = e.response) == null ? void 0 : n.data)}` : e instanceof Error ? `${e.name}: ${e.message}
${e.stack}` : JSON.stringify(e);
}, qe = (e, t, r, n) => {
  const o = V(e);
  console.error(o), r.status(400).json({ error: o });
};
function ne(...e) {
  return function(t) {
    t.apply(null, e);
  };
}
function Ke(e) {
  return Math.round(e / 100) / 10;
}
function Ze(e) {
  return Math.round(e / 1e3);
}
function z(e, t, r) {
  switch (oe(e, t)) {
    case "==":
      switch (r) {
        case "<=":
        case "==":
        case ">=":
          return !0;
        default:
          return !1;
      }
    case "<":
      switch (r) {
        case "<":
        case "<=":
          return !0;
        default:
          return !1;
      }
    case ">":
      switch (r) {
        case ">":
        case ">=":
          return !0;
        default:
          return !1;
      }
  }
}
function oe(e, t) {
  let [r, n, o] = e.split(".").map((a) => parseInt(a)), [s, i, c] = t.split(".").map((a) => parseInt(a));
  return r < s ? "<" : r > s ? ">" : n < i ? "<" : n > i ? ">" : o < c ? "<" : o > c ? ">" : "==";
}
const $ = (e) => e < 1 ? parseFloat(e.toFixed(1)) : parseFloat(Math.floor(e).toString()), R = (e) => e < 1 ? parseFloat(e.toFixed(1)) : parseFloat((Math.trunc(e * 100) / 100).toString()), ie = (e, t) => e.length ? e[Math.floor(t * e.length)] : void 0, Xe = (e) => e >= 0 && e < 4 ? P(7, 50) : e >= 4 && e < 8 ? P(51, 100) : e >= 8 && e < 12 ? P(100, 200) : e >= 12 && e < 16 ? P(200, 300) : e >= 16 && e < 20 ? P(300, 400) : P(400, 500), P = (e, t) => Math.floor(e + Math.random() * (t + 1 - e)), h = (e) => y.duration(e.Duration).asWeeks(), p = (e) => y.duration(e.Duration).asMonths(), se = (e, t, r) => {
  let n = P(e, t);
  return r.includes(n) ? se(e, t, r) : n;
};
function Qe(e, t) {
  if (t[e])
    return t[e];
  if (e > 100 || e < 0)
    return "";
  let r = e % 10, n = e - r;
  return t[n] + " " + t[r];
}
const ae = (e) => !1;
function et(e, t, r) {
  let n = ce(t);
  ue(e, n.left, r);
}
function ce(e) {
  var o, s;
  let t = (o = e.parentNode) == null ? void 0 : o.getBoundingClientRect(), r = e.getBoundingClientRect(), n = {};
  return n.top = r.top - t.top, n.right = r.right - t.right, n.bottom = r.bottom - t.bottom, n.left = r.left - t.left + ((s = e.parentNode) == null ? void 0 : s.scrollLeft), n;
}
const le = function(e) {
  return e < 0.5 ? 4 * e * e * e : (e - 1) * (2 * e - 2) * (2 * e - 2) + 1;
};
function ue(e, t, r, n) {
  let o = e.scrollLeft, s = t - o, i = performance.now();
  function c() {
    let u = (performance.now() - i) / 1e3 / r;
    r == 0 ? e.scrollTo(o + s, 0) : e.scrollLeft = o + s * le(u), u < 1 ? window.requestAnimationFrame(c) : n && n();
  }
  c();
}
function tt(e, t, r) {
  const n = document.createElement("link");
  n.rel = e, n.href = t, r && Object.keys(r).forEach((o) => {
    typeof r[o] == "boolean" ? n.setAttribute(o, "1") : n[o] = r[o];
  }), document.head.appendChild(n);
}
const rt = (e) => e[0].MarketID === e[1].MarketID, nt = (e, t, r, n) => {
  const o = n(e);
  return o.success || (e = t, r(e, o.message)), e;
};
function ot(e, t) {
  return e.reduce(
    (r, n) => Object.assign(r, { [t(n)]: n }),
    {}
  );
}
function it(e, t) {
  let r = {};
  for (let n in e)
    r[n] = t(e[n]);
  return r;
}
const st = (e) => e.split(":").join("-").replace(/[^A-Za-z0-9_-]/g, "");
function at(e, t, r) {
  let n, o;
  if (t !== r && 0 <= t && t <= e.length && 0 <= r && r <= e.length) {
    if (o = e[t], t < r)
      for (n = t; n < r; n++)
        e[n] = e[n + 1];
    else
      for (n = t; n > r; n--)
        e[n] = e[n - 1];
    e[r] = o;
  }
  return e;
}
const fe = (e, t) => {
  let r = [];
  for (let n of e)
    r.some((o) => t(n, o)) || r.push(n);
  return r;
};
function ct(e, t) {
  return e ? (e = e.trim(), e.length <= t ? e : (e = e.slice(0, t), e.trim() + "...")) : "";
}
const lt = (e) => e && e[0].toUpperCase() + e.slice(1);
function ut(e, t) {
  let r = [];
  for (let n = e; n <= t; n++)
    r.push((n < 10 ? "0" : "") + n);
  return r;
}
const ft = (e, t) => {
  let r = new Date(), n = new Date(r.getFullYear(), r.getMonth()), o = new Date(t, e), s = new Date(n.getFullYear(), o.getMonth()), i = n.getFullYear() - o.getFullYear();
  return n < s && (i = i - 1), de(Math.floor(i));
}, de = (e) => {
  switch (e) {
    case 0:
    case 1:
    case 2:
      return 10;
    case 3:
      return 13;
    case 4:
      return 14;
    case 5:
      return 15;
    case 6:
      return 16;
    default:
      return 17;
  }
}, dt = (e) => {
  switch (e) {
    case "Age_0_3":
      return 2;
    case "Age_3_4":
      return 3;
    case "Age_4_5":
      return 4;
    case "Age_5_6":
      return 5;
    case "Age_6_7":
      return 6;
    default:
      return 7;
  }
}, pt = (e) => {
  switch (e) {
    case 0:
      return "None";
    case 10:
      return "Age_0_3";
    case 13:
      return "Age_3_4";
    case 14:
      return "Age_4_5";
    case 15:
      return "Age_5_6";
    case 16:
      return "Age_6_7";
    default:
      return "Age_7_100";
  }
}, gt = (e) => {
  const t = e.products.length;
  switch (t) {
    case 0:
      e.handleZeroCount(), e.handleFewCount(t);
      break;
    case 1:
      e.handleOneCount(), e.handleFewCount(t);
      break;
    case 2:
      e.handleTwoCount();
      break;
    default:
      e.handleManyCount(t);
  }
  e.products.map(
    te.validate
  ).some((n) => !n.success) && e.validationErrorCallback();
}, pe = (e) => {
  const t = e.slice(500).reduce((c, a) => c + a, 0) / e.length / 2, r = me(
    e.reduce((c, a) => c + a, 0) / e.length
  ), n = e.slice().sort((c, a) => c - a), o = ie(n, 0.9) || 0, s = n[Math.ceil(n.length / 2)], i = ge(r);
  return {
    FPS_AVERAGE: r,
    FPS_SLOWEST_10: o,
    FPS_MEDIAN_50: s,
    FPS_LEVEL: i,
    FPS_RECENT_AVG: t
  };
}, ge = (e) => e > 50 ? "perfect" : e > 35 ? "great" : e > 20 ? "good" : e > 10 ? "playable" : "terrible", me = (e) => Math.ceil(1e3 / e), ye = (e, t) => e > 0 ? "p_" + e : "d_" + t, mt = (e) => new Promise(function(t, r) {
  let n = document.createElement("script");
  n.src = e, n.onload = () => t(n), n.onerror = () => r(`\u041E\u0448\u0438\u0431\u043A\u0430 \u0437\u0430\u0433\u0440\u0443\u0437\u043A\u0438 \u0441\u043A\u0440\u0438\u043F\u0442\u0430 ${e}`), document.head.append(n);
}), A = (e) => !Array.isArray(e) && typeof e == "object" && e !== null, he = (e, t, r, n) => {
  const o = Object.assign({}, e);
  for (let s in t) {
    const i = e[s], c = t[s], a = n ? `${n}.${s}` : s;
    i ? typeof i != typeof c || A(i) && !A(c) || A(c) && !A(i) ? r({
      key: a,
      oldValue: i,
      newValue: c
    }) : typeof c == "object" && !Array.isArray(c) ? o[s] = he(
      i,
      c,
      r,
      a
    ) : o[s] = c : o[s] = c;
  }
  return o;
};
function yt(e) {
  for (let t = e.length - 1; t > 0; t--) {
    const r = Math.floor(Math.random() * (t + 1));
    [e[t], e[r]] = [e[r], e[t]];
  }
  return e;
}
const _e = async (e) => {
  try {
    return await e;
  } catch (t) {
    throw C.isAxiosError(t) && console.error(`${t.config.method} ${t.config.url} failed!`), t;
  }
}, ht = async (e, t) => {
  let r = t;
  for (; ; ) {
    try {
      return await e();
    } catch (n) {
      if (r === 0)
        throw n;
      const o = Math.pow(2, t - r) * 1e3;
      await new Promise((s) => setTimeout(s, o));
    }
    r--;
  }
}, _t = (e, t) => Object.keys(e).filter((n) => t(e[n])).reduce(
  (n, o) => Object.assign(n, { [o]: e[o] }),
  {}
), wt = (e, t = 1) => e.slice(0, t < 0 ? 0 : t), we = (e) => {
  if (e = e.replace(/\s+/g, ""), e.indexOf(".") == -1 && e.indexOf(",") == -1)
    return e;
  let t = e.slice(-3)[0];
  if (t == "." || t == ",") {
    let r = t == "." ? "," : ".";
    e = e.replace(r, " "), e = e.replace(",", "."), e = e.replace(/\s+/g, "");
  } else
    e = e.replace(",", "").replace(".", "");
  return e;
}, j = (e) => !e && location.hostname == "localhost", H = (e) => e.startsWith("/cache/") || e.startsWith("/fresh-cache/") || e.startsWith("/fresh/"), Pe = (e) => {
  var t;
  return ((t = e.match(/^\/(?:cache|fresh-cache|fresh)\/[^\/]+(\/.*)?$/)) == null ? void 0 : t[1]) || "";
}, Se = (e, t) => {
  if (!H(t))
    return t;
  let r = t.split("/")[2], n = e[r], o = Pe(t);
  return `${n}${o}`;
}, Te = (e) => !e || !e.ForceUpgradeNeeded && e.Downloading ? "downloaded" : e.Downloading && e.Progress == 0 ? "in_queue" : e.Downloading && (e.Progress || 0) > 0 ? "show_progress" : !!e.IsBuildIn && !!e.ForceUpgradeNeeded || e.ForceUpgradeNeeded || !e.CurrentVersion ? "show_download_button" : "downloaded";
function Pt(e, ...t) {
  let r = { ...e };
  for (let n of t)
    delete r[n];
  return r;
}
function St(e, t) {
  return e.replace(/{{\s*([0-9A-Za-z]+)\s*}}/g, function(r, n) {
    return t[n] || "";
  });
}
const ve = (e) => e % 10 === 1 && e % 100 !== 11 ? 0 : e % 10 >= 2 && e % 10 <= 4 && (e % 100 < 10 || e % 100 >= 20) ? 1 : 2, Ce = (e, ...t) => t.reduce((r, n, o) => {
  const s = r.replace(new RegExp(`\\{${o}\\}`, "g"), n);
  return isNaN(+n) ? s : be(s, o, ve(+n));
}, e), be = (e, t, r) => [...e.matchAll(new RegExp(`{${t}:([^}]+)}`, "g"))].reduce(
  (n, o) => n.replace(o[0], Ee(o[1].split("|"), r)),
  e
);
function Ee(e, t) {
  for (; !e[t]; )
    if (t--, t < 0)
      return e[0];
  return e[t];
}
const Tt = (e) => {
  let t = Math.floor(e % 60), r = Math.floor(e / 60 % 60), n = Math.floor(e / (60 * 60) % 24);
  return [Math.floor(e / (60 * 60 * 24)), n, r, t];
}, Y = (e) => {
  const t = { ...e };
  return Object.values(e).forEach(
    (r) => typeof r == "number" && delete t[r]
  ), t;
}, vt = (e) => Object.fromEntries(Object.entries(Y(e)).map((t) => t.reverse())), Ie = (e) => Object.keys(Y(e)), Ct = (e) => e.replace(/([^\d]|^)(\d)([^\d])/g, "$10$2$3"), Ae = /^(([^<>()[\]\.,;:\s@\"]+(\.[^<>()[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/, bt = (e) => Boolean(e.match(Ae));
function $e(e, t) {
  return e < t ? "<" : e > t ? ">" : "==";
}
function N(e, t, r) {
  switch ($e(e, t)) {
    case "==":
      switch (r) {
        case "<=":
        case "==":
        case ">=":
          return !0;
        default:
          return !1;
      }
    case "<":
      switch (r) {
        case "<":
        case "<=":
        case "!=":
          return !0;
        default:
          return !1;
      }
    case ">":
      switch (r) {
        case ">":
        case ">=":
        case "!=":
          return !0;
        default:
          return !1;
      }
  }
}
const Et = (e, t, r) => {
  let n = L(e.tile) ? k(e.tile) : "";
  const o = t[n];
  if (o === "active" || o === "hidden")
    return o === "active";
  const s = e.filter && e.filter.length > 0 ? e.filter : e.tile.filter || [];
  return ke(s, r);
}, ke = (e, t) => {
  var n;
  let r = e;
  for (let o = 0; o < r.length; o++) {
    let s = ((n = r == null ? void 0 : r[o]) == null ? void 0 : n.conditions) || [];
    if (s)
      for (let i = 0; i < s.length; i++) {
        let c = s[i];
        if (!Le(c, t))
          return !1;
      }
  }
  return !0;
}, Le = (e, t) => {
  var n, o;
  const r = e.mod || "==";
  switch (e.type) {
    case "language":
      return e.mod === "==" ? t.language == e.value : t.language != e.value;
    case "android_version":
    case "ios_version":
      return z(
        ((n = t.osInfo) == null ? void 0 : n.version) || "",
        e.value || "",
        r
      );
    case "memory_size":
      return N(
        t.systemMemorySize || 0,
        Number(e.value),
        e.mod || "=="
      );
    case "platform":
      return N(
        ((o = t.osInfo) == null ? void 0 : o.os) || "",
        e.value || "",
        e.mod || "=="
      );
    case "client_version":
      return z(
        t.clientVersion || "",
        e.value || "",
        r
      );
    case "subscriptionKind":
      return N(
        t.subscriptionKind,
        e.value || "",
        r
      );
    default:
      return !0;
  }
};
function L(e) {
  return "target" in e;
}
const Me = (e) => !L(e);
function k(e) {
  return !e || !L(e) ? "" : U(e.target);
}
const U = (e) => {
  if (!e)
    return "";
  switch (e.type) {
    case "wg":
    case "mg":
    case "bg":
      return e.gameId;
    case "island":
      return e.type;
    case "partner":
      return e.name;
    case "locked":
      return e.gameId || e.type;
  }
  return "";
};
function De(e) {
  if (!e)
    return [];
  switch (e.type) {
    case "wg":
    case "mg":
    case "island":
    case "partner":
      return [];
    case "bg":
      return e.params;
    case "locked":
      return (e == null ? void 0 : e.params) || [];
  }
  return [];
}
const B = (e) => {
  var n;
  if (!e)
    return "";
  let t = [];
  "params" in e && (t = e.params || []);
  const r = t.find((o) => o.name === "type");
  return ((n = r == null ? void 0 : r.value) == null ? void 0 : n.text) || "";
}, It = (e) => e, At = (e, t, r, n) => e ? !1 : n || r ? !0 : !(t != null && t.IsBuildIn || Te(t) == "downloaded"), $t = (e) => {
  var t, r, n;
  return ((t = e.remoteConfig) == null ? void 0 : t.tinkoff_payment) && ((n = (r = e.remoteConfig) == null ? void 0 : r.tinkoff_client_white_list) == null ? void 0 : n.includes(e.clientVersion));
}, kt = (e) => {
  var t, r, n, o, s;
  return (r = (t = e.remoteConfig) == null ? void 0 : t.cloudpayments) != null && r.force_activate ? !0 : (s = (o = (n = e.remoteConfig) == null ? void 0 : n.cloudpayments) == null ? void 0 : o.conditions) == null ? void 0 : s.some((i) => {
    var c, a;
    if (Object.keys(i).length > 0) {
      let l = [];
      return i.language && l.push(
        Boolean(
          ((c = i.language) == null ? void 0 : c.toLowerCase()) === e.language.toLowerCase()
        )
      ), i.client_white_list && l.push((a = i.client_white_list) == null ? void 0 : a.includes(e.clientVersion)), l.length > 0 && l.every(Boolean);
    }
    return !1;
  });
}, W = async (e, t) => {
  try {
    const n = (await _e(C.get(e))).data, o = re.validate(n);
    if (!o.success) {
      t(
        JSON.stringify(o.extraDetails || {})
      );
      return;
    }
    return o.value;
  } catch (r) {
    t(V(r));
    return;
  }
}, Lt = (e, t) => {
  var o;
  const r = (o = t == null ? void 0 : t.tile_catalog_config) == null ? void 0 : o.config_urls, n = e !== "None" && (r == null ? void 0 : r[e]) || (t == null ? void 0 : t.tile_catalog_config["config_url@2"]);
  return n ? I.resolve(n) : "";
}, Mt = async (e, t, r) => {
  for (let s = 0; s < 2; ++s) {
    r.onTryStart(e, s + 1);
    const i = await W(
      e,
      r.onValidationFailed
    );
    if (!i) {
      r.onTryFinished(!1, e), r.onFileRemoveRequest(e);
      continue;
    }
    return r.onTryFinished(!0, e), i;
  }
  const o = await W(
    t,
    r.onValidationFailed
  );
  if (r.onFallbackReceived(!!o, t), o)
    return o;
}, Dt = (e, t) => {
  e = { tile: { name: "root", tiles: e.tiles } }, t = t.slice(), t.shift();
  const r = [e];
  for (; r.length; ) {
    const n = r.shift();
    if (!t.length)
      return n;
    const o = t.shift(), s = n.tile.tiles;
    if (!!s) {
      for (let i = 0; i < s.length; ++i)
        if (s[i].tile.name === o && !s[i].tile.target) {
          r.push(s[i]);
          break;
        }
    }
  }
  return null;
}, Oe = (e) => {
  if (!e)
    return [];
  const t = [], r = [...e.tiles];
  for (; r.length; ) {
    const n = r.shift();
    L(n.tile) ? t.push(n) : r.push(...n.tile.tiles);
  }
  return t;
}, Ot = (e) => e ? fe(
  Oe(e),
  (t, r) => k(t.tile) == k(r.tile) && B(t.tile.target) === B(r.tile.target)
) : [], Ft = (e, t) => {
  const r = {
    tile: { name: "root", tiles: e.tiles }
  }, n = {};
  n.root = null;
  const o = [r];
  let s = "";
  for (; o.length; ) {
    const a = o.shift(), l = a.tile.tiles;
    if (l.some((u) => k(u.tile) === t)) {
      s = a.tile.name || "";
      break;
    }
    for (let u = 0; u < l.length; ++u) {
      const d = l[u].tile;
      Me(d) && (n[d.name || ""] = a.tile.name, o.push({ tile: d }));
    }
  }
  const i = [];
  let c = s;
  for (; c; )
    i.push(c), c = n[c] || "";
  return i.length ? i.reverse() : [r.tile.name];
}, Fe = (e, t) => JSON.parse(JSON.stringify(e)).reduce((n, o) => {
  if (o.tile.target)
    return t(o) && n.push(o), n;
  {
    const s = Fe(o.tile.tiles, t);
    return s.length && (o.tile.tiles = s, n.push(o)), n;
  }
}, []);
function Rt(e, t) {
  let r, n;
  return function() {
    const o = arguments, s = this;
    return r || (r = !0, setTimeout(() => r = !1, t), n = e.apply(s, o)), n;
  };
}
const Nt = (e, t) => {
  let r = {};
  for (let n of t)
    e && e.hasOwnProperty(n) && (r[n] = e[n]);
  return r;
}, Ut = (e) => (e != null && e["override-freeContentAmount"] ? e == null ? void 0 : e["new-freeContentAmount"] : e == null ? void 0 : e.tile.freeContentAmount) || 0, Bt = (e) => {
  var t;
  return Boolean((t = e == null ? void 0 : e.blockedByPaywall) != null ? t : e == null ? void 0 : e.tile.blockedByPaywall);
}, xt = (e, t) => (...r) => {
  try {
    return e(...r);
  } catch (n) {
    t && t(n);
    return;
  }
}, zt = (e) => e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), jt = (e, t) => Promise.race([
  e,
  new Promise(
    (r, n) => setTimeout(() => n("timeout"), t || 0)
  )
]), Wt = (e, t) => {
  const r = e;
  return t ? r === "plusKids" : r === "plus";
}, Re = (e, t) => e.type === "wg" || e.type === "bg" ? t || e.configUrl : "", Gt = (e, t, r) => (n) => {
  const o = U(n), s = B(n), i = e[o + s] || "easy";
  return {
    gameId: U(n),
    configUrl: Re(n, r),
    gameParams: {
      blockedByPaywall: !1,
      freeContentAmount: 0,
      difficulty: i,
      gamer: "Child",
      params: De(n),
      ...t
    },
    m: "catalog.w.launch_game"
  };
}, Vt = (e) => (t) => ({
  meta_payload: JSON.stringify(e(t.meta)),
  config: t.iterations.map((n) => ({
    games: n.games.map((o) => ({
      base_level: o.level,
      base_payload: JSON.stringify(e(o.game))
    }))
  })),
  "iteration-cycle-index": t["iteration-cycle-index"],
  "blocked-game-index": t["blocked-game-index"],
  "blocked-iteration-index": t["blocked-iteration-index"]
}), Ht = async (e, t) => {
  let r = t;
  try {
    r = await e;
  } catch {
  }
  return r;
}, Yt = (e) => ({
  client_version: e.clientVersion,
  user_id: ye(e.parentId, e.udid),
  web_module: "",
  device_os: e.os,
  language: e.language,
  system_memory_size: e.systemMemorySize,
  free_memory_space: e.freeMemorySpaceMb,
  is_subscribe: e.subscriptionKind != "Free",
  subscription_kind: e.subscriptionKind
});
class m {
  constructor() {
    E(this, "listeners", []);
    E(this, "count", 0);
  }
  raise(...t) {
    this.count++, this.listeners.forEach(ne(...t));
  }
  on(t) {
    return this.listeners.push(t), () => this.off(t);
  }
  once(t) {
    var r = this, n = function(...o) {
      r.off(n), t(...o);
    };
    this.listeners.push(n);
  }
  off(t) {
    this.listeners = this.listeners.filter(function(r) {
      return r != t;
    });
  }
  removeAllListeners() {
    this.listeners = [];
  }
}
const Jt = {
  tinkoff_payment_toggle: new m(),
  show_toast: new m(),
  schedule_push_notification: new m(),
  tinkoff_get_subscriptions: new m(),
  open_buy_error_popup: new m(),
  run_previous_buying_attempt: new m(),
  request_subscriptions: new m(),
  tinkoff_subscriptions_update: new m(),
  unity_focus_changed: new m(),
  yandex_landing_opened: new m()
}, qt = () => {
  y && (y.updateLocale("en", {
    relativeTime: {
      M: "%d month",
      y: "%d year",
      w: "%d week",
      dd: (e) => {
        if (e < 7)
          return `${e} days`;
        {
          const t = Math.round(e / 7);
          return t > 1 ? `${t} weeks` : `${t} week`;
        }
      }
    },
    longDateFormat: {
      LLL: "MMMM Do"
    }
  }), y.updateLocale("ru", {
    longDateFormat: {
      LLL: "D MMMM"
    },
    relativeTime: {
      M: "%d \u043C\u0435\u0441\u044F\u0446",
      y: "%d \u0433\u043E\u0434",
      w: "%d \u043D\u0435\u0434\u0435\u043B\u044F",
      dd: (e) => {
        if (e < 7)
          return `${e} \u0434\u043D\u0435\u0439`;
        {
          const t = Math.round(e / 7);
          return t > 1 ? t + " \u043D\u0435\u0434\u0435\u043B\u044C" : t + " \u043D\u0435\u0434\u0435\u043B\u044F";
        }
      }
    }
  }));
}, Kt = {
  Rus: "ru",
  Eng: "en"
};
var J = {};
(function(e) {
  Object.defineProperty(e, "__esModule", { value: !0 }), e.serialize = e.parse = e.InvalidDurationError = void 0;
  const t = [
    { unit: "years", symbol: "Y" },
    { unit: "months", symbol: "M" },
    { unit: "weeks", symbol: "W" },
    { unit: "days", symbol: "D" },
    { unit: "hours", symbol: "H" },
    { unit: "minutes", symbol: "M" },
    { unit: "seconds", symbol: "S" }
  ], r = (a, l) => `((?<${a}>-?\\d*[\\.,]?\\d+)${l})?`, n = new RegExp([
    "(?<negative>-)?P",
    r("years", "Y"),
    r("months", "M"),
    r("weeks", "W"),
    r("days", "D"),
    "(T",
    r("hours", "H"),
    r("minutes", "M"),
    r("seconds", "S"),
    ")?"
  ].join(""));
  function o(a) {
    if (!(a === "" || a === void 0 || a === null))
      return parseFloat(a.replace(",", "."));
  }
  e.InvalidDurationError = new Error("Invalid duration");
  function s(a) {
    const l = n.exec(a);
    if (!l || !l.groups)
      throw e.InvalidDurationError;
    let u = !0;
    const d = {};
    for (const { unit: w } of t)
      l.groups[w] && (u = !1, d[w] = o(l.groups[w]));
    if (u)
      throw e.InvalidDurationError;
    const _ = d;
    return l.groups.negative && (_.negative = !0), _;
  }
  e.parse = s;
  const i = (a, l) => {
    if (!a)
      return;
    let u = a.toString();
    const d = u.indexOf("e");
    if (d > -1) {
      const _ = parseInt(u.slice(d + 2), 10);
      u = a.toFixed(_ + d - 2);
    }
    return u + l;
  };
  function c(a) {
    return !a.years && !a.months && !a.weeks && !a.days && !a.hours && !a.minutes && !a.seconds ? "PT0S" : [
      a.negative && "-",
      "P",
      i(a.years, "Y"),
      i(a.months, "M"),
      i(a.weeks, "W"),
      i(a.days, "D"),
      (a.hours || a.minutes || a.seconds) && "T",
      i(a.hours, "H"),
      i(a.minutes, "M"),
      i(a.seconds, "S")
    ].filter(Boolean).join("");
  }
  e.serialize = c;
})(J);
const f = (e) => e.Type === g.Regular || e.Type === g.Intro && e.IsTrialOrIntroPeriodPassed || e.Type === g.Trial ? e.Price : e.Type === g.Intro ? parseFloat(M(e)) : e.Price, T = (e) => decodeURI(e.LocalizedPrice || "").replace(/[\w\d.,\s]/g, "") || e.Currency, Zt = {
  getPlanProps: (e, t, r, n, o, s) => e.Type === g.Trial ? {
    title: `${p(e)} ${t.month} ${r}`,
    body: [
      `${T(e)}${f(e)} / ${s[p(e)] || ""}`,
      n
    ],
    caption: `${T(e)}${R(
      f(e) / p(e)
    )} / ${t.month.replace(".", "")}. ${o}`
  } : {
    title: `${p(e)} ${t.month}`,
    body: [
      `${T(e)}${f(e)} / ${s[p(e)] || ""}`,
      n
    ],
    caption: `${T(e)}${R(
      f(e) / p(e)
    )} / ${t.month}. ${o}`
  },
  getBtnLabel: (e, t, r) => e.Type === g.Trial ? t : r,
  getFirstPlanPrice: (e, t, r) => `${T(e)}${f(e)} / ${r[p(e)] || ""} (${T(e)}${R(
    f(e) / p(e)
  )} / ${t.month})`,
  getTrialExpirationDay: (e) => y().add(e, "d").format("LLL")
}, Xt = {
  getPaywallHeaderTitle: (e, t, r) => {
    const n = Ie(g)[e - 1];
    return n == "Intro" ? { value: t, type: n } : n == "Trial" ? { value: r, type: n } : {
      value: "",
      type: "Regular"
    };
  },
  getOneOfferButtonLabels: (e, t) => {
    const r = f(e) / p(e);
    return e.Type === g.Intro ? {
      label: t.introLabel,
      subLabel: t.introSubLabel
    } : e.Type == g.Trial ? {
      label: t.trialLabel,
      subLabel: `${t.trialSubLabel} ${f(e)} ${e.Currency} / ${t.year} (${$(r)} ${e.Currency} / ${t.month})`
    } : {
      label: `${t.regularLabel} ${f(e)} ${e.Currency} / ${t.year}`,
      subLabel: `(${$(r)} ${e.Currency} / ${t.month})`
    };
  },
  getTariffComponent: (e) => {
    const t = e.subscriptionProducts[e.subIdx];
    return t.Type === g.Intro ? Ue(e) : t.Type == g.Trial ? Be(e) : Ne(e);
  },
  getBtnLabels: ({
    dict: e,
    os: t,
    text: r,
    sub: n
  }) => n.Type === g.Intro ? {
    label: e.btnLabel(
      r,
      `${M(n)} ${n.Currency}`
    ),
    subLabel: ""
  } : n.Type == g.Trial ? {
    label: `${e.btnTrial(
      t,
      n.LocalizedPrice || n.Price + " " + n.Currency
    )}`,
    subLabel: e.btnSubLabel(t)
  } : {
    label: e.btnLabel(
      r,
      n.LocalizedPrice || n.Price + " " + n.Currency
    ),
    subLabel: ""
  }
}, M = (e) => {
  var t;
  return we(
    (t = decodeURI(e.IntroductoryPrice || "")) == null ? void 0 : t.replace(/[^\d.,]/g, "")
  );
}, Ne = (e) => {
  const {
    parentsCount: t,
    subIdx: r,
    subscriptionProducts: n,
    tariffDictionary: o,
    sale: s
  } = e, i = n[r], c = f(n[0]), a = f(n[1]), l = Math.round(
    h(n[1]) / h(n[0])
  ), u = c * l, d = Math.round(100 * (1 - a / u)), _ = h(i), w = f(i) / p(i);
  let D = p(i) > 1 ? `${$(w)} ${i.Currency} / ${o.pricePeriod}` : "", b = ((F, ze) => {
    let x = "", X = Math.floor(
      r == 1 ? Math.min(...t) * 0.6 : Math.max(...t)
    );
    return F && (x = o.trialText), [o.description(X), x];
  })(
    !!ae(),
    i.FreeTrialPeriodNative || ""
  ), O = !!s && `${d}% ${o.saleText}`;
  return {
    price: decodeURI(`${f(i)} ${i.Currency}`),
    period: y.duration(_, "weeks").humanize(),
    currency: i.Currency || "",
    priceMonth: D,
    desc: b[0],
    trialText: b[1],
    sale: O || "",
    ...r == 1 ? { type: "tariff--year" } : {}
  };
}, Ue = (e) => {
  const {
    parentsCount: t,
    subIdx: r,
    subscriptionProducts: n,
    tariffDictionary: o,
    sale: s
  } = e;
  let i = n[r], c = M(i);
  const a = xe(i), l = h(i);
  let u = `${a}% ${o.saleText}`;
  return {
    price: `${c} ${i.Currency}`,
    period: y.duration(l, "weeks").humanize(),
    currency: i.Currency || "",
    priceMonth: `${i.Price} ${i.Currency}`,
    desc: o.tariffIntroInfo.descInfo(
      i.Duration || "",
      a
    ),
    sale: u,
    ...r == 1 ? { type: "tariff--year" } : {}
  };
}, Be = (e) => {
  const {
    parentsCount: t,
    subIdx: r,
    subscriptionProducts: n,
    tariffDictionary: o,
    sale: s
  } = e, i = n[r], c = f(n[0]), a = f(n[1]), l = Math.round(
    h(n[1]) / h(n[0])
  ), u = c * l, d = Math.round(100 * (1 - a / u)), _ = h(i), w = f(i) / p(i);
  let D = p(i) > 1 ? `${$(w)} ${i.Currency} / ${o.pricePeriod}` : "", b = (() => {
    let F = Math.floor(
      r == 1 ? Math.min(...t) * 0.6 : Math.max(...t)
    );
    return [o.description(F), o.trialText];
  })(), O = !!s && `${d}% ${o.saleText}`;
  return {
    price: decodeURI(`${f(i)} ${i.Currency}`),
    period: y.duration(_, "weeks").humanize(),
    currency: i.Currency || "",
    priceMonth: D,
    desc: b[0],
    trialText: b[1],
    sale: O || "",
    ...r == 1 ? { type: "tariff--year" } : {}
  };
}, xe = (e) => {
  if (!e)
    return 0;
  let t = M(e);
  const n = parseFloat(t) / e.Price;
  return Math.round(100 - n * 100);
}, Qt = (e, t) => {
  const r = f(e) / p(e), n = f(t) / p(t);
  return Math.round(100 * (1 - r / n));
}, er = {
  getTrialExpirationDay: (e, t, r) => e === "date" ? y().add(t).format("LLL") : Object.entries(J.parse(t)).map(
    ([n, o]) => `${o} ${Ce(
      r[n],
      o
    )}`.trim()
  ).join(" ")
}, tr = "blue", rr = "start_journey", nr = "default", or = 2, ir = "40_games_open", sr = "start_now", ar = "normal", cr = {
  sendEvent: "/msg/analytic/sendEvent",
  setUserProperty: "/msg/analytic/setUserProperty",
  setUserProperties: "/msg/analytic/setUserProperties"
}, lr = "/unity/games/status", ur = 1e3 * 60 * 60 * 24 * 5;
let v = [], q = !0, G = 0;
const fr = () => {
  setTimeout(() => {
    q = !1;
  }, 5e3);
  function e(t) {
    const r = t - G;
    G = t, v.push(r), v.length >= 10100 && (v = v.slice(100)), requestAnimationFrame(e);
  }
  requestAnimationFrame(e);
}, dr = () => !q && v.length > 1e3 ? pe(v) : {}, pr = {
  getPaymentState: (e) => C.post("https://securepay.tinkoff.ru/v2/GetState", e),
  init: (e) => C.post("https://securepay.tinkoff.ru/v2/Init", e),
  getCardList: (e) => C.post(
    "https://securepay.tinkoff.ru/v2/GetCardList",
    e
  )
}, gr = {
  recommendationScreen: {
    gameTap: (e, t, r, n, o, s) => ({
      Action: e,
      Intent: "Game",
      GameName: t,
      GameLoaded: r,
      BlockByPaywall: n,
      Time: o,
      GameTags: s,
      Screen: "Recommendations"
    }),
    opened: (e, t, r, n, o, s, i, c, a, l, u, d) => ({
      Action: "Start",
      GamesRecommended: e,
      ScreenType: t,
      GamesRecommendedListBlockedByPaywall: r,
      GamesRecommendedBlockedByPaywall: r.length,
      GamesRecommendedListNotLoaded: n,
      GamesRecommendedNotLoaded: n.length,
      "Catalog-Config-Version": o,
      GamesList: s,
      SubscriptionKind: c,
      GamesLoadedList: i,
      GameRecommendedBigTile: a,
      RecommendationsType: l,
      GamesRecommendedList: u,
      TimerSettings: d
    }),
    goCatalog: (e) => ({
      Action: "Exit",
      Intent: "Catalog",
      Time: e,
      Screen: "Recommendations"
    }),
    cantLoadScreenError: (e) => ({
      Action: "ExitBeforeStart",
      Reason: e
    })
  },
  callOfflinePopup: (e) => ({
    Intent: "Wifi",
    Status: "Offline",
    Screen: e
  }),
  paywall: {
    commonProps: (e) => ({ ScreenType: e }),
    loaded: () => ({
      Action: "Start",
      Intent: "Loaded"
    }),
    close: () => ({
      Action: "Interaction",
      Intent: "Close",
      BuyCase: "Non-payer"
    }),
    subscriptionTap: (e, t) => ({
      Action: "Interaction",
      Intent: "SubscriptionTap",
      Subscription: e.MarketID,
      SubscriptionDuration: e.Duration || h(e).toString(),
      currency: e.Currency || "",
      discount: e.DiscountString || "",
      isIntroOrTrial: !!e.IsProductIntroOrTrial,
      localizedPrice: e.LocalizedPrice || String(e.Price),
      position: t || "",
      trialOrIntroPeriodExpired: !!e.IsTrialOrIntroPeriodPassed,
      trialPeriod: e.FreeTrialPeriodNative || ""
    }),
    buyButtonTap: (e, t) => ({
      Action: "Interaction",
      Intent: "BuySubscriptionTap",
      Subscription: e.MarketID,
      SubscriptionDuration: e.Duration || h(e).toString(),
      currency: e.Currency || "",
      discount: e.DiscountString || "",
      isIntroOrTrial: !!e.IsProductIntroOrTrial,
      localizedPrice: e.LocalizedPrice || String(e.Price),
      position: t || "",
      trialOrIntroPeriodExpired: !!e.IsTrialOrIntroPeriodPassed,
      trialPeriod: e.FreeTrialPeriodNative || ""
    }),
    recoverSubsClick: (e) => ({
      Action: "Interaction",
      Intent: "RecoverTap",
      Subscription: e
    })
  }
}, mr = () => {
  if ("cp" in window)
    return;
  const e = document.querySelector(
    "script[src*=cloudpayments]"
  );
  if (e) {
    const t = document.createElement("script");
    t.src = e.src + "?random=" + Date.now(), e.remove(), document.body.appendChild(t);
  }
}, yr = (e, t) => {
  let r = (o) => o && typeof o == "object";
  if (!(r(e) && r(t)))
    return e === t;
  const n = [[e, t]];
  for (; n.length > 0; ) {
    const [o, s] = n.pop();
    for (const i of Object.keys(o))
      if (r(o[i]) && r(s[i])) {
        if (Object.keys(o[i]).length !== Object.keys(s[i]).length)
          return !1;
        n.push([o[i], s[i]]);
      } else if (o[i] !== s[i])
        return !1;
  }
  return !0;
}, hr = () => `
           
(function() {

    if (window.zebraCodeInjected) {
        return
    }
   
    function ___sendMessage___(msg, args = {}) {
        let copy = JSON.parse(JSON.stringify(args || {}))
        copy["m"] = msg
        window.Unity.call(fixUriEscaping(JSON.stringify(copy)))
    }
    function fixUriEscaping(str) {
        return str.split("%").join("\\u0025")
    }

    const logAnalytics = (msg, type) => {
        ___sendMessage___("analytics.w.send_event", { eventName:"LandingEvents", data: {
            type: type,
            message: msg
        } })
    }
    var oldLog = console.log
    var oldErr = console.error

	console.log = function () {
		var args = Array.prototype.slice.call(arguments)
		oldLog.apply(console, args)
		var text = args
			.map(function (x) {
				return typeof x === "string" ? x : JSON.stringify(x)
			})
			.join(" ")

        logAnalytics(text, "consoleLog")
       
	}
    
    console.error = function () {
		var args = Array.prototype.slice.call(arguments)
		oldErr.apply(console, args)
		var text = args
			.map(function (x) {
				return typeof x === "string" ? x : JSON.stringify(x)
			})
			.join(" ")

        logAnalytics(text, "consoleError")
	}

    const init = (onSuccess) => {
        let closeResult = "close"
        const createBtn = (name, onClick) => {
            const btn = document.createElement("button")
            btn.innerHTML = name                
            btn.onclick = onClick
            return btn
        }
        const closeButton = document.createElement("div")
    
        const types = {
            PURCHASE_SUCCESS_DATA: "PURCHASE_SUCCESS_DATA",
            ERROR: "ERROR",
            SUCCESS: "SUCCESS",
        }
       
        const closeWV = () => {
            window.location = "http://localhost/close_current_webview?result=" + closeResult
        }
        closeButton.onclick =  () => {
            closeWV()
        }
        closeButton.classList.add("zeb-close")
        const closeButtonStyles = document.createElement("style")
        closeButtonStyles.innerHTML = \`
        .zeb-close {
            position:relative;
            width: 32px;
            height: 32px;
            margin-left:16px;
        }
        .zeb-close:before, .zeb-close:after {
            position: absolute;
            left: 15px;
            content: ' ';
            height: 33px;
            width: 2px;
            background-color: white;
        }
        .zeb-close:before {
            transform: rotate(45deg);
        }
        .zeb-close:after {
            transform: rotate(-45deg);
        }

        html {
            background: white;
        }
        #header, .header {
           top: 40px;
        }
        #root {
            margin-top: 40px;
        }
        .UserID-Wrapper  {
            pointer-events: none
        }
        .zeb-container {
            width: 100%;
            height: 40px;
            background: #3048B1;
            position: fixed;
            display: flex;
            top: 0;
            align-items: center;
            justify-content: space-between;
            z-index: 99;
        }
        .language-select {
            pointer-events: none;
            display: none !important;
        }
        .zeb-fake {
           
        }
        
        \`
    
        
        const container = document.createElement("div")
        const root = document.querySelector("#root")
        if (root) {
            document.head.appendChild(closeButtonStyles)
            onSuccess()
            
            const widgetEventHandler = (e) => {
                const data = JSON.parse(e.data || "{}")
                logAnalytics(JSON.stringify(data), "postMessage")

                if (data.source != "YandexMBPaymentWidget") return
                
                if (data.type === "ERROR") {
                    closeResult = "error"
                }

                if (data.type === "PURCHASE_SUCCESS_DATA") {
                    closeResult = "success"
                    ___sendMessage___("yandex.w.verify_purchase", {})
                }

                if (data.type === "SUCCESS") {
                    closeResult = "success"
                    setTimeout(() => {
                        closeWV()
                    }, 2000)
                }
            }
            window.addEventListener("message", (e) => {
                try {
                    widgetEventHandler(e)
                }
                catch {
                    
                }
            })

            container.classList.add("zeb-container")
            container.appendChild(closeButton)
        
            root.classList.add("zeb-fake")
            document.body.prepend(container)
        }
        else {
        }
    }

    clearInterval(window.zebraInterval)
    window.zebraInterval = setInterval(() => {
        init(() => {
            window.zebraCodeInjected = true
            clearInterval(window.zebraInterval)
        })
        
    }, 0)
})()
`;
export {
  cr as ANALYTICS_WEBSERVER_URLS,
  gr as AnalyticsGenerator,
  tr as BTN_COLOR_DEFAULT,
  Ae as EMAIL_REGEX,
  m as EventClass,
  ur as FIVE_DAYS_MS,
  lr as GAME_STATUSES_URL,
  or as GOOD_SUBSCRIPTIONS_COUNT,
  ar as ONBOARDING_AGES_ORDER_DEFAULT,
  sr as PAYWALL_BUY_TEXT_DEFAULT,
  ir as PAYWALL_OFFER_TEXT_DEFAULT,
  Jt as SharedEventBus,
  pr as TinkoffApi,
  I as UrlResolver,
  nt as ValidateAndGetDefaultValue,
  rr as WELCOME_BTN_CAPTION_DEFAULT,
  nr as WELCOME_NEW_SCREEN_VARIANT_DEFAULT,
  hr as YandexWebviewInjectCode,
  rt as __UNFUCK_SUBSCRIPTIONS_HIDDEN,
  $e as _compareStrings,
  Ct as addZerosToSingleDigit,
  tt as appendLink,
  Ke as approxSeconds,
  ot as arrayToRecord,
  jt as asyncWithTimeout,
  Bt as blockedByPaywall,
  Se as cacheUrlToHttp,
  ft as calcAgeCategory,
  me as calcFps,
  pe as calculateFpsStats,
  xe as calculateIntroSalePercent,
  Xe as calculateParentCount,
  Qt as calculateProfitPercentBetweenTwoSubs,
  ne as callWithArgsInForEach,
  lt as capitalizeText,
  Le as checkCondition,
  Te as checkDownloadStatus,
  N as compareStrings,
  z as compareVersions,
  ct as cutString,
  yr as deepEqual,
  fe as deleteDuplicates,
  Ut as deriveFreeContentAmount,
  mr as downloadCloudPaymentsScript,
  W as downloadValidCatalogConfig,
  le as easeInOutCubic,
  Ie as enumKeys,
  Y as enumObject,
  vt as enumObjectReversed,
  zt as escapeRegExp,
  It as exhaustive_switch,
  ht as exponentialBackoff,
  qe as exressHandleError,
  B as extractGameType,
  ke as filterCondition,
  Fe as filterSection,
  Dt as findSection,
  Ft as findSectionWithGame,
  Ot as flatAndDeleteDuplicates,
  Oe as flatTiles,
  Je as flatten,
  Ce as format,
  St as formatString,
  Et as gameVisible,
  ut as generateNumberArray,
  Lt as getCatalogConfigUrl,
  Re as getGameConfigUrl,
  k as getGameId,
  U as getGameIdFromTarget,
  De as getGameParams,
  Gt as getGamePayload,
  ye as getIntercomUserId,
  Yt as getIntercomUserInfo,
  Qe as getNumberString,
  Pe as getPathFromCacheUrl,
  Tt as getPaywallTimer,
  R as getPriceWithDecimalPlaces,
  ce as getRelativePos,
  $ as getRoundedPrice,
  Wt as hasYandexSub,
  L as isGame,
  Me as isSection,
  ae as isTrial,
  mt as loadScript,
  de as mapAgeToCategory,
  dt as mapAgeToNumberEdge,
  pt as mapCategoryToAgeString,
  it as mapRecord,
  he as mergeObjects,
  Pr as moment,
  qt as momentInitLocaleUpdater,
  Kt as momentLangMap,
  at as moveElementOnArray,
  we as normalizePriceString,
  _t as objectfilter,
  Pt as omit,
  T as parseCurrency,
  M as parseIntroPrice,
  p as parseMonth,
  f as parsePrice,
  h as parseWeeks,
  Xt as paywall,
  ie as percentile,
  Nt as pick,
  ve as pluralizer,
  dr as prepareCurrentFpsStats,
  P as random,
  se as randomExclude,
  At as restrictedInOffline,
  Ze as roundSeconds,
  j as runningOnLocalMobileWebserver,
  st as sanitizeGameIdForHtmlId,
  ue as scrollTo,
  et as scrollToElm,
  gt as setSubscriptionsProducts,
  kt as shouldShowCloudPaymentsPaywall,
  $t as shouldShowTinkoffPaywall,
  yt as shuffleArray,
  fr as startFpsMeasuring,
  V as stringifyErr,
  wt as take,
  Rt as throttle,
  Vt as transformGameMapConfig,
  Ht as tryAwait,
  Mt as tryDownloadCatalogConfig,
  xt as trycatch,
  Zt as twoStepsPaywall,
  _e as unwrapAxiosError,
  H as urlIsUsingCache,
  bt as validateEmail,
  Ye as wait,
  er as yandexPaywall
};
