import { AvailableSubscriptionProducts, Initialize } from '@zebrainy/front-types';
export declare const AnalyticsGenerator: {
    recommendationScreen: {
        gameTap: (Action: 'Tap' | 'TimeIsUp', GameName: string, GameLoaded: boolean, BlockByPaywall: boolean, Time: number, GameTags: string[]) => {
            Action: "Tap" | "TimeIsUp";
            Intent: string;
            GameName: string;
            GameLoaded: boolean;
            BlockByPaywall: boolean;
            Time: number;
            GameTags: string[];
            Screen: string;
        };
        opened: (GamesRecommended: number, ScreenType: 'type2games' | 'type3games', GamesRecommendedListBlockedByPaywall: string[], GamesRecommendedListNotLoaded: string[], CatalogConfigVersion: string, GamesList: string[], GamesLoadedList: string[], SubscriptionKind: Initialize['subscriptionKind'], GameRecommendedBigTile: string, RecommendationsType: 'random' | 'recommend', GamesRecommendedList: string[], TimerSettings: number) => {
            Action: string;
            GamesRecommended: number;
            ScreenType: "type2games" | "type3games";
            GamesRecommendedListBlockedByPaywall: string[];
            GamesRecommendedBlockedByPaywall: number;
            GamesRecommendedListNotLoaded: string[];
            GamesRecommendedNotLoaded: number;
            'Catalog-Config-Version': string;
            GamesList: string[];
            SubscriptionKind: "Free" | "Plus" | "Premium";
            GamesLoadedList: string[];
            GameRecommendedBigTile: string;
            RecommendationsType: "random" | "recommend";
            GamesRecommendedList: string[];
            TimerSettings: number;
        };
        goCatalog: (Time: number) => {
            Action: string;
            Intent: string;
            Time: number;
            Screen: string;
        };
        cantLoadScreenError: (Reason: string) => {
            Action: string;
            Reason: string;
        };
    };
    callOfflinePopup: (Screen: string) => {
        Intent: string;
        Status: string;
        Screen: string;
    };
    paywall: {
        commonProps: (ScreenType: PaywallScreenType) => {
            ScreenType: PaywallScreenType;
        };
        loaded: () => {
            Action: string;
            Intent: string;
        };
        close: () => {
            Action: string;
            Intent: string;
            BuyCase: string;
        };
        subscriptionTap: (subscription: AvailableSubscriptionProducts, position?: string) => {
            Subscription: string;
            SubscriptionDuration: string;
            currency: string;
            discount: string;
            isIntroOrTrial: boolean;
            localizedPrice: string;
            position: string;
            trialOrIntroPeriodExpired: boolean;
            trialPeriod: string;
            Action: string;
            Intent: string;
        };
        buyButtonTap: (subscription: AvailableSubscriptionProducts, position?: string) => {
            Subscription: string;
            SubscriptionDuration: string;
            currency: string;
            discount: string;
            isIntroOrTrial: boolean;
            localizedPrice: string;
            position: string;
            trialOrIntroPeriodExpired: boolean;
            trialPeriod: string;
            Action: string;
            Intent: string;
        };
        recoverSubsClick: (subId: string) => {
            Action: string;
            Intent: string;
            Subscription: string;
        };
    };
};
export type PaywallScreenType = 'Main' | 'AllPlans' | 'TinkoffPay';
//# sourceMappingURL=analytics.d.ts.map